#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <limits.h>
#include <unistd.h>
//#include <sys/stat.h>

extern "C" {
	int __libc_chdir (const char *path);
	DIR *__libc_opendir (const char *path);
	int __libc_stat (const char *path, struct stat *st);
	int __libc_prev_lstat (const char *path, struct stat *st);
}
/*
	Make sure the cdrom is mounted
*/
static void checkmount()
{
	FILE *fin = fopen ("/proc/mounts","r");
	if (fin != NULL){
		bool is_mounted = false;
		char buf[2*PATH_MAX];
		while (fgets(buf,sizeof(buf)-1,fin)!=NULL){
			char dev[PATH_MAX],dir[PATH_MAX],stuff[PATH_MAX];
			if (sscanf (buf,"%s %s %s",dev,dir,stuff)>=2
				&& strcmp(dir,"/cdrom")==0){
				is_mounted = true;
				break;
			}
		}
		fclose (fin);
		if (!is_mounted) system ("mount /cdrom");
	}
}

void checkmount (const char *path)
{
	// Check mount is itself opening file. The open is trapped in
	// netaudio.cc and itself call checkmount. So we protect against
	// reentrancy. This is simpler then forcing function below to
	// to use lower level function.
	static bool checkmounting = false;
	if (!checkmounting){
		checkmounting = true;
		if (strcmp(path,"/cdrom")==0
			|| strncmp(path,"/cdrom/",7)==0){
			checkmount();
		}else{
			char curpath[PATH_MAX];
			if (getcwd(curpath,sizeof(curpath))!=NULL
				&& curpath[0] == '/'
				&& curpath[1] == '\0'){
				if (strcmp(path,"cdrom")==0
					|| strncmp(path,"cdrom/",6)==0){
					checkmount();
				}
			}
		}
		checkmounting = false;
	}
}

extern "C" int chdir (const char *path)
{
	checkmount (path);
	return __libc_chdir (path);
}

extern "C" DIR *opendir (const char *path)
{
	checkmount (path);
	return __libc_opendir (path);
}

#if 0
extern "C" int stat (const char *path, struct stat *st)
{
fprintf (stderr,"stat %s\n",path);
	checkmount (path);
	return -1; // __libc_stat (path,st);
}

extern "C" int prev_lstat (const char *path, struct stat *st)
{
fprintf (stderr,"lstat %s\n",path);
	checkmount (path);
	return 	__libc_prev_lstat (path,st);
}
#endif
